/*! \page page3 GnoclNewPackage
  \section sec Gnome Virtual Terminal Emulation Widget.
  Implementation of NewPackage.
  \subsection subsection1 An example section

*/

#include <stdlib.h>
#include <gnocl.h>

#include <webkit/webkit.h>

Tcl_ObjCmdProc gnoclWebKitCmd;

#define DEBUG 0

static WebKitWebView* web_view;

/**
\brief
\author WJG
\date 12.03.09
*/
static int webKitFunc (
    ClientData data,
    Tcl_Interp *interp,
    int objc,
    Tcl_Obj * const objv[] )
{
    return TCL_OK;
}


/**
\brief
\author  William J Giddings
\date   30-Oct-2010
\note
**/
int Gnoclwebkit_Init ( Tcl_Interp *interp )
{

    if ( Tcl_InitStubs ( interp, "8.3", 0 ) == NULL )
        return TCL_ERROR;

    if ( Tcl_PkgRequire ( interp, "Gnocl", VERSION, 0 ) == NULL )
        return TCL_ERROR;

    if ( Tcl_PkgProvide ( interp, "GnoclWebKit", VERSION ) != TCL_OK )
        return TCL_ERROR;

    Tcl_CreateObjCommand ( interp, "gnocl::webKit", gnoclWebKitCmd, NULL, NULL );

    return TCL_OK;
}

/**
\brief
\author  William J Giddings
\date   06-Jan-2010
\note
**/
int gnoclWebKitCmd ( ClientData data, Tcl_Interp *interp, int objc, Tcl_Obj * const objv[]  )
{

    int  idx;

    char        *key = NULL;
    int         ret = TCL_ERROR;

    GtkScrolledWindow *scrolled;
    //WebKitWebView* web_view;


    gchar* uri = "http://www.google.com";

    web_view = WEBKIT_WEB_VIEW (webkit_web_view_new ());

    scrolled =  GTK_SCROLLED_WINDOW ( gtk_scrolled_window_new ( NULL, NULL ) );

    gtk_scrolled_window_set_policy ( scrolled, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC );

    gtk_container_add ( GTK_CONTAINER ( scrolled ), GTK_WIDGET ( web_view ) );

    webkit_web_view_open ( web_view, uri );

    gtk_widget_grab_focus (GTK_WIDGET (web_view));

    gtk_widget_show_all ( GTK_WIDGET ( scrolled ) );


    return gnoclRegisterWidget ( interp, GTK_WIDGET ( scrolled ) , webKitFunc );

}
