#---------------
# test-webkit.tcl
#---------------
# Created by William J Giddings
# 06-Jan-10
#---------------
# Description:
#
#---------------

#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0" "$@"

package require Gnocl
package require GnoclWebKit

set builderFile "browser.xml"
set builderFileObjects [gnocl::builder file $builderFile]
#---------------
# Register the widgets using their glade names.
#---------------
foreach item $builderFileObjects {
    foreach {gnocl builder} $item {}
    set $builder $gnocl
}

# create browser widget
set wk1 [gnocl::webKit -url "http://www.google.com"]

$hbox1 add $wk1 -fill {1 1} -expand 1

$window1 configure \
    -defaultHeight 400 \
    -defaultWidth 640 \
    -title "Gnocl WebKit Demo" \
    -onDestroy { exit }

$window1 show

gnocl::mainLoop
